---
title: llarp::dns::sd::Platform
summary: a dns platform that sets dns via systemd resolved 

---

# llarp::dns::sd::Platform



a dns platform that sets dns via systemd resolved 


`#include <sd_platform.hpp>`

Inherits from [llarp::dns::I_Platform](Classes/classllarp_1_1dns_1_1I__Platform.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual | **[~Platform](Classes/classllarp_1_1dns_1_1sd_1_1Platform.md#function-~platform)**() =default |
| virtual void | **[set_resolver](Classes/classllarp_1_1dns_1_1sd_1_1Platform.md#function-set-resolver)**(unsigned int if_index, [llarp::SockAddr](Classes/structllarp_1_1SockAddr.md) dns, bool global) override<br>Attempts to set lokinet as the DNS server.  |

## Additional inherited members

**Public Functions inherited from [llarp::dns::I_Platform](Classes/classllarp_1_1dns_1_1I__Platform.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~I_Platform](Classes/classllarp_1_1dns_1_1I__Platform.md#function-~i-platform)**() =default |


## Public Functions Documentation

### function ~Platform

```cpp
virtual ~Platform() =default
```


### function set_resolver

```cpp
virtual void set_resolver(
    unsigned int if_index,
    llarp::SockAddr dns,
    bool global
) override
```

Attempts to set lokinet as the DNS server. 

**Parameters**: 

  * **if_index** &ndash; the interface index to which we add the DNS servers, this can be gotten from the interface name e.g. lokitun0 (Typically tun_endpoint.GetIfName().) and then put through if_nametoindex(). 
  * **dns** &ndash; the listening address of the lokinet DNS server 
  * **global** &ndash; whether to set up lokinet for all DNS queries (true) or just .loki & .snode addresses (false). 


**Reimplements**: [llarp::dns::I_Platform::set_resolver](Classes/classllarp_1_1dns_1_1I__Platform.md#function-set-resolver)


throws if unsupported or fails.


-------------------------------

Updated on 2024-11-03 at 04:10:01 +0000