---
title: llarp::routing::TransferTrafficMessage

---

# llarp::routing::TransferTrafficMessage





Inherits from [llarp::routing::IMessage](Classes/structllarp_1_1routing_1_1IMessage.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual void | **[Clear](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#function-clear)**() override |
| size_t | **[Size](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#function-size)**() const |
| bool | **[PutBuffer](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#function-putbuffer)**(const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & buf, uint64_t counter)<br>append buffer to X  |
| virtual bool | **[BEncode](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#function-bencode)**([llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) const override |
| virtual bool | **[DecodeKey](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#function-decodekey)**(const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & k, [llarp_buffer_t](Classes/structllarp__buffer__t.md) * val) override |
| virtual bool | **[HandleMessage](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#function-handlemessage)**([IMessageHandler](Classes/structllarp_1_1routing_1_1IMessageHandler.md) * h, [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * r) const override |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| std::vector< [llarp::Encrypted](Classes/structllarp_1_1Encrypted.md)< MaxExitMTU+ExitOverhead > > | **[X](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#variable-x)**  |
| service::ProtocolType | **[protocol](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#variable-protocol)**  |
| size_t | **[_size](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md#variable--size)**  |

## Additional inherited members

**Public Functions inherited from [llarp::routing::IMessage](Classes/structllarp_1_1routing_1_1IMessage.md)**

|                | Name           |
| -------------- | -------------- |
| | **[IMessage](Classes/structllarp_1_1routing_1_1IMessage.md#function-imessage)**() =default |
| virtual | **[~IMessage](Classes/structllarp_1_1routing_1_1IMessage.md#function-~imessage)**() =default |
| bool | **[operator<](Classes/structllarp_1_1routing_1_1IMessage.md#function-operator<)**(const [IMessage](Classes/structllarp_1_1routing_1_1IMessage.md) & other) const |

**Public Attributes inherited from [llarp::routing::IMessage](Classes/structllarp_1_1routing_1_1IMessage.md)**

|                | Name           |
| -------------- | -------------- |
| [PathID_t](Classes/structllarp_1_1PathID__t.md) | **[from](Classes/structllarp_1_1routing_1_1IMessage.md#variable-from)**  |
| uint64_t | **[S](Classes/structllarp_1_1routing_1_1IMessage.md#variable-s)**  |
| uint64_t | **[version](Classes/structllarp_1_1routing_1_1IMessage.md#variable-version)**  |


## Public Functions Documentation

### function Clear

```cpp
inline virtual void Clear() override
```


**Reimplements**: [llarp::routing::IMessage::Clear](Classes/structllarp_1_1routing_1_1IMessage.md#function-clear)


### function Size

```cpp
inline size_t Size() const
```


### function PutBuffer

```cpp
bool PutBuffer(
    const llarp_buffer_t & buf,
    uint64_t counter
)
```

append buffer to X 

### function BEncode

```cpp
virtual bool BEncode(
    llarp_buffer_t * buf
) const override
```


**Reimplements**: [llarp::routing::IMessage::BEncode](Classes/structllarp_1_1routing_1_1IMessage.md#function-bencode)


### function DecodeKey

```cpp
virtual bool DecodeKey(
    const llarp_buffer_t & k,
    llarp_buffer_t * val
) override
```


**Reimplements**: [llarp::routing::IMessage::DecodeKey](Classes/structllarp_1_1routing_1_1IMessage.md#function-decodekey)


### function HandleMessage

```cpp
virtual bool HandleMessage(
    IMessageHandler * h,
    AbstractRouter * r
) const override
```


**Reimplements**: [llarp::routing::IMessage::HandleMessage](Classes/structllarp_1_1routing_1_1IMessage.md#function-handlemessage)


## Public Attributes Documentation

### variable X

```cpp
std::vector< llarp::Encrypted< MaxExitMTU+ExitOverhead > > X;
```


### variable protocol

```cpp
service::ProtocolType protocol;
```


### variable _size

```cpp
size_t _size = 0;
```


-------------------------------

Updated on 2024-11-03 at 04:10:02 +0000