---
title: llarp/constants/path.hpp

---

# llarp/constants/path.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::path](Namespaces/namespacellarp_1_1path.md)**  |




## Source code

```cpp
#pragma once

#include <chrono>
#include <cstddef>

#include <llarp/util/types.hpp>
#include <llarp/util/time.hpp>

namespace llarp
{
  namespace path
  {
    constexpr std::size_t max_len = 8;
    constexpr std::size_t default_len = 4;
    constexpr std::size_t pad_size = 128;
    constexpr std::chrono::milliseconds default_lifetime = 20min;
    constexpr std::chrono::milliseconds min_intro_lifetime = default_lifetime / 2;
    constexpr auto intro_spread_slices = 4;
    constexpr std::chrono::milliseconds intro_path_spread = default_lifetime / intro_spread_slices;
    constexpr std::chrono::milliseconds intro_stale_threshold =
        default_lifetime - intro_path_spread;
    constexpr std::size_t min_intro_paths = 4;
    constexpr auto build_timeout = 10s;

    constexpr auto latency_interval = 20s;
    constexpr auto alive_timeout = latency_interval * 1.5;

    constexpr std::size_t transit_hop_queue_size = 256;

  }  // namespace path
}  // namespace llarp
```


-------------------------------

Updated on 2024-11-03 at 04:10:02 +0000
