---
title: llarp/service/pendingbuffer.hpp

---

# llarp/service/pendingbuffer.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::service](Namespaces/namespacellarp_1_1service.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::service::PendingBuffer](Classes/structllarp_1_1service_1_1PendingBuffer.md)**  |




## Source code

```cpp
#pragma once

#include "protocol.hpp"
#include <llarp/util/buffer.hpp>
#include <vector>

namespace llarp::service
{
  struct PendingBuffer
  {
    std::vector<byte_t> payload;
    ProtocolType protocol;

    inline llarp_buffer_t
    Buffer()
    {
      return llarp_buffer_t{payload};
    }

    PendingBuffer(const llarp_buffer_t& buf, ProtocolType t) : payload{buf.copy()}, protocol{t}
    {}
  };

}  // namespace llarp::service
```


-------------------------------

Updated on 2024-11-03 at 04:10:02 +0000
