---
title: llarp/service/name.hpp

---

# llarp/service/name.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::service](Namespaces/namespacellarp_1_1service.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::service::EncryptedName](Classes/structllarp_1_1service_1_1EncryptedName.md)**  |




## Source code

```cpp
#pragma once
#include <llarp/crypto/types.hpp>
#include "address.hpp"

namespace llarp::service
{
  struct EncryptedName
  {
    SymmNonce nonce;
    std::string ciphertext;

    std::optional<Address>
    Decrypt(std::string_view name) const;
  };

  bool
  NameIsValid(std::string_view name);

}  // namespace llarp::service
```


-------------------------------

Updated on 2024-11-03 at 04:10:02 +0000
