---
title: llarp::routing

---

# llarp::routing



## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::routing::CloseExitMessage](Classes/structllarp_1_1routing_1_1CloseExitMessage.md)**  |
| struct | **[llarp::routing::DataDiscardMessage](Classes/structllarp_1_1routing_1_1DataDiscardMessage.md)**  |
| struct | **[llarp::routing::DHTMessage](Classes/structllarp_1_1routing_1_1DHTMessage.md)**  |
| struct | **[llarp::routing::GrantExitMessage](Classes/structllarp_1_1routing_1_1GrantExitMessage.md)**  |
| struct | **[llarp::routing::IMessage](Classes/structllarp_1_1routing_1_1IMessage.md)**  |
| struct | **[llarp::routing::IMessageHandler](Classes/structllarp_1_1routing_1_1IMessageHandler.md)**  |
| struct | **[llarp::routing::InboundMessageParser](Classes/structllarp_1_1routing_1_1InboundMessageParser.md)**  |
| struct | **[llarp::routing::ObtainExitMessage](Classes/structllarp_1_1routing_1_1ObtainExitMessage.md)**  |
| struct | **[llarp::routing::PathConfirmMessage](Classes/structllarp_1_1routing_1_1PathConfirmMessage.md)**  |
| struct | **[llarp::routing::PathLatencyMessage](Classes/structllarp_1_1routing_1_1PathLatencyMessage.md)**  |
| struct | **[llarp::routing::PathTransferMessage](Classes/structllarp_1_1routing_1_1PathTransferMessage.md)**  |
| struct | **[llarp::routing::RejectExitMessage](Classes/structllarp_1_1routing_1_1RejectExitMessage.md)**  |
| struct | **[llarp::routing::TransferTrafficMessage](Classes/structllarp_1_1routing_1_1TransferTrafficMessage.md)**  |
| struct | **[llarp::routing::UpdateExitMessage](Classes/structllarp_1_1routing_1_1UpdateExitMessage.md)**  |
| struct | **[llarp::routing::UpdateExitVerifyMessage](Classes/structllarp_1_1routing_1_1UpdateExitVerifyMessage.md)**  |

## Types

|                | Name           |
| -------------- | -------------- |
| using std::shared_ptr< [IMessageHandler](Classes/structllarp_1_1routing_1_1IMessageHandler.md) > | **[MessageHandler_ptr](Namespaces/namespacellarp_1_1routing.md#using-messagehandler-ptr)**  |

## Attributes

|                | Name           |
| -------------- | -------------- |
| constexpr size_t | **[ExitPadSize](Namespaces/namespacellarp_1_1routing.md#variable-exitpadsize)**  |
| constexpr size_t | **[MaxExitMTU](Namespaces/namespacellarp_1_1routing.md#variable-maxexitmtu)**  |
| constexpr size_t | **[ExitOverhead](Namespaces/namespacellarp_1_1routing.md#variable-exitoverhead)**  |

## Types Documentation

### using MessageHandler_ptr

```cpp
using llarp::routing::MessageHandler_ptr = typedef std::shared_ptr<IMessageHandler>;
```




## Attributes Documentation

### variable ExitPadSize

```cpp
constexpr size_t ExitPadSize = 512 - 48;
```


### variable MaxExitMTU

```cpp
constexpr size_t MaxExitMTU = 1500;
```


### variable ExitOverhead

```cpp
constexpr size_t ExitOverhead = sizeof(uint64_t);
```





-------------------------------

Updated on 2024-11-03 at 04:10:02 +0000